aboutsummaryrefslogtreecommitdiffstats
path: root/scripts/combined-image.sh
diff options
context:
space:
mode:
authorJames <>2015-11-04 11:49:21 +0000
committerJames <>2015-11-04 11:49:21 +0000
commit716ca530e1c4515d8683c9d5be3d56b301758b66 (patch)
tree700eb5bcc1a462a5f21dcec15ce7c97ecfefa772 /scripts/combined-image.sh
downloadtrunk-47381-master.tar.gz
trunk-47381-master.tar.bz2
trunk-47381-master.zip
trunk-47381HEADmaster
Diffstat (limited to 'scripts/combined-image.sh')
-rw-r--r--scripts/combined-image.sh34
1 files changed, 34 insertions, 0 deletions
diff --git a/scripts/combined-image.sh b/scripts/combined-image.sh
new file mode 100644
index 0000000..5472b2c
--- /dev/null
+++ b/scripts/combined-image.sh
@@ -0,0 +1,34 @@
+#!/bin/sh
+
+BLKSZ=65536
+
+[ -f "$1" -a -f "$2" ] || {
+ echo "Usage: $0 <kernel image> <rootfs image> [output file]"
+ exit 1
+}
+
+IMAGE=${3:-openwrt-combined.img}
+
+# Make sure provided images are 64k aligned.
+kern="${IMAGE}.kernel"
+root="${IMAGE}.rootfs"
+dd if="$1" of="$kern" bs=$BLKSZ conv=sync 2>/dev/null
+dd if="$2" of="$root" bs=$BLKSZ conv=sync 2>/dev/null
+
+# Calculate md5sum over combined kernel and rootfs image.
+md5=$(cat "$kern" "$root" | md5sum -)
+
+# Write image header followed by kernel and rootfs image.
+# The header is padded to 64k, format is:
+# CI magic word ("Combined Image")
+# <kernel length> length of kernel encoded as zero padded 8 digit hex
+# <rootfs length> length of rootfs encoded as zero padded 8 digit hex
+# <md5sum> checksum of the combined kernel and rootfs image
+( printf "CI%08x%08x%32s" \
+ $(stat -c "%s" "$kern") $(stat -c "%s" "$root") "${md5%% *}" | \
+ dd bs=$BLKSZ conv=sync;
+ cat "$kern" "$root"
+) > ${IMAGE} 2>/dev/null
+
+# Clean up.
+rm -f "$kern" "$root"